/************************************************************************/
/*                                                                      */
/*                                                                      */
/*    *****                       *****                                 */
/*      *****                   *****                                   */
/*        *****               *****                                     */
/*          *****           *****                                       */
/*  ***************       ***************                               */
/*  *****************   *****************                               */
/*  ***************       ***************                               */
/*          *****           *****           TheNetNode                  */
/*        *****               *****         Portable                    */
/*      *****                   *****       Network                     */
/*    *****                       *****     Software                    */
/*                                                                      */
/* This file is part of "TheNetNode" - Software Package                 */
/*                                                                      */
/* Copyright (C) 1996  NORD><LINK e.V. Braunschweig                     */
/*                                                                      */
/* This program is free software; you can redistribute it and/or modify */
/* it under the terms of the NORD><LINK ALAS (Allgemeine Lizenz fr     */
/* Amateurfunk Software) as published by Hans Georg Giese (DF2AU)       */
/* on 13/Oct/1992; either version 1, or (at your option) any later      */
/* version.                                                             */
/*                                                                      */
/* This program is distributed WITHOUT ANY WARRANTY only for further    */
/* development and learning purposes. See the ALAS (Allgemeine Lizenz   */
/* fr Amateurfunk Software).                                           */
/*                                                                      */
/* You should have received a copy of the NORD><LINK ALAS (Allgemeine   */
/* Lizenz fr Amateurfunk Software) along with this program; if not,    */
/* write to NORD><LINK e.V., Hinter dem Berge 5, D-3300 Braunschweig    */
/*                                                                      */
/* Dieses Programm ist PUBLIC DOMAIN, mit den Einschrnkungen durch     */
/* die ALAS (Allgemeine Lizenz fr Amateurfunk Software), entweder      */
/* Version 1, verffentlicht von Hans Georg Giese (DF2AU),              */
/* am 13.Oct.1992, oder (wenn gewnscht) jede sptere Version.          */
/*                                                                      */
/* Dieses Programm wird unter Haftungsausschlu vertrieben, aus-        */
/* schlielich fr Weiterentwicklungs- und Lehrzwecke. Nheres          */
/* knnen sie der ALAS (Allgemeine Lizenz fr Amateurfunk Software)     */
/* entnehmen.                                                           */
/*                                                                      */
/* Sollte dieser Software keine ALAS (Allgemeine Lizenz fr Amateurfunk */
/* Software) beigelegen haben, wenden Sie sich bitte an                 */
/* NORD><LINK e.V., Hinter dem Berge 5, D-38108 Braunschweig            */
/*                                                                      */
/*                                                                      */
/************************************************************************/

/*------------------------------------------------ Funktionen in MAIN.C */
void    mainf(void);
void    quit_program(int);
void    init_local(void);

#ifdef ST          /*------------------------------- Fr ST ----------- */
void    stime(time_t *);
BOOLEAN enable_port(UWORD);
BOOLEAN disable_port(UWORD);
void    tzset(void);
char   *tempnam(const char *, const char *);
#endif

#ifdef MC68302     /*------------------------------- Fr TNC3 --------*/
void    stime(time_t *);
void    getftime(char *, struct ftime *);
char   *tempnam(const char *, const char *);
void    mem_init(void);
#endif

/*------------------------------------------------ allgemeine Low-Level */

void    DIinc(void);
void    decEI(void);

BOOLEAN init_hardware(int argc, char *argv[]);
void    exit_hardware(void);
void    reboot_system(void);

void    init_console(void);
void    exit_console(void);

BOOLEAN ishget(void);
char    hgetc(void);
void    toggle_rts(void);

int     xchdir(const char *);
int     xaccess(const char *, int );
int     xfindfirst(const char *pathname, struct ffblk *ffblk, int attrib);
int     xfindnext(struct ffblk *ffblk);
FILE   *xfopen(const char *, const char *);
int     xremove(const char *);
int     xrename(const char *, const char *);
char   *normfname(char *);

void    shellsrv(void);
BOOLEAN l7tosh(MBHEAD *mbhd);
BOOLEAN tnnshell(char *);
void    tnnexec(char *);

unsigned long coreleft(void);
void    update_timer(void);

/*-------------------------------------------------- Funktionen in L1.C */

void    l1rxtx(void);
void    l1init(void);
void    l1exit(void);
void    l1timr(UWORD);
void    kicktx(int);
void    l1ctl(int,int);
BOOLEAN iscd(int);
int     l1attach(int, char *);
void    l1detach(int);
void    l1hwstr(int, MBHEAD *);
void    l1hwcfg(int, MBHEAD *);
void    l1enum(MBHEAD *);
void    l1stat(char *devname, MBHEAD *mbp);
void    l1sclr(char *);

/*------------------------------------------------- Funktionen in L2A.C */

void    l2(void);

/*------------------------------------------------- Funktionen in L2B.C */

void    chknoa(void);
void    newlnk(void);
void    dsclnk(void);
BOOLEAN itolnk(int pid, BOOLEAN, MBHEAD *);
WORD    digipt(MBHEAD *);
void    i2tolx(BOOLEAN);
BOOLEAN srxdNR(void);
BOOLEAN isnxti(void);
void    inilnk(void);
void    setiSRTT(void);
void    clrlnk(void);
void    mclrlk(void);
void    disc(void);
void    reslnk(void);
void    inilbl(void);
char    outsdI(void);
char    itxwnd(void);
void    sdoi(void);
void    sdi(int, int);
BOOLEAN splcpy(WORD, MBHEAD *, MBHEAD *);
void    sdui(char *, char *, char *, char, MBHEAD *);
void    l2newstate(WORD);
void    l2stma(STENTRY[]);
void    acklnk(LNKBLK *);
void    rejlnk(LNKBLK *);
LNKBLK *getlnk(UBYTE, char *, char *, char *);

/*------------------------------------------------- Funktionen in L2C.C */

void    t2rrr(void);
void    t2rnrr(void);
void    t2rejr(void);
void    setT1(void);
void    clrT1(void);
void    setT2(int);
void    clrT2(void);
void    setT3(void);
void    clrT3(void);
void    setRTT(void);
void    clrRTT(void);
void    xnull(void);
void    xrrc(void);
void    xrrr(void);
void    xrnrc(void);
void    xrnrr(void);
void    xrejr(void);
void    sendS(int);
void    xdm(void);
void    xua(void);
void    xsabm(void);
void    xdisc(void);
void    stxcfr(void);
void    stxfad(void);
WORD    setNR(int);
void    sdl2fr(MBHEAD *, BOOLEAN);
MBHEAD  *cpyfb(MBHEAD *);
BOOLEAN takfhd(MBHEAD *);
BOOLEAN getfid(char *, MBHEAD *);
MBHEAD  *makfhd(int);
void    putvia(char *,MBHEAD *);
void    putfid(char *,MBHEAD *);
BOOLEAN istome(char *);
BOOLEAN cmpcal(char *, char *);
BOOLEAN cmpidl(char *, char *);
BOOLEAN cmpid(char *, char *);
void    cpyidl(char *, char *);
void    cpyid(char *, char *);
char   *ndigipt(char *);
int     istomev(void);
void    addid(char *,char *);
void    addidl(char *,char *);
void    l2tolx(WORD);

/*------------------------------------------------- Funktionen in L2D.C */

BOOLEAN l1put(WORD);
WORD    l1get(WORD);
void    rlmlsl(LEHEAD *);
void    putchr(WORD, MBHEAD *);
char    getchr(MBHEAD *);
#define save(mbp,mbbp,mbgc) mbbp=mbp->mbbp;mbgc=mbp->mbgc
#define restore(mbp,mbbp,mbgc) mbp->mbbp=mbbp;mbp->mbgc=mbgc

/*------------------------------------------------- Funktionen in L2E.C */

void    l2init(void);
void    sdfrmr(char);
void    xfrmr(void);
void    autopar(int);
void    autopers(int);

/*------------------------------------------------- Funktionen in L3A.C */
BOOLEAN register_network(int, int);
void unregister_network(void);
PEER *register_peer(void);
void unregister_peer(PEER *);
int find_node_ssid_range(char *);
int find_node_this_ssid(char *);
int add_node(char *);
void del_node(int);
void drop_unreachable_nodes(void);
int  add_route(PEER *, char *, unsigned);
void update_route(PEER *, int, unsigned);
int  update_alias(int, char *);
int  update_lt(PEER *, int, int);
int  update_ssid(int, int);
int  update_opt(int, char *, int);
void smooth(unsigned long *, unsigned long);
void update_peer_quality(PEER *, unsigned long, unsigned long);
void reset_peer(PEER *);
void connect_peer(PEER *);
void disconnect_peer(PEER *);
int  get_next_prim(int num);
/*void update_quality(PEER *, char *, unsigned, int);*/
unsigned getquality(unsigned route_qual, PEER *pp);
#define cpyals(x,y) memmove(x,y,6)
#define cmpals(x,y) (!strnicmp(x,y,6))
void set_peer_typ(PEER *, int);

/*------------------------------------------------- Funktionen in L3B.C */
void    l3init(void);
void    l3rx(void);
void    l3tx(void);
void    l3rest(void);
BOOLEAN l2tol3(WORD);
void    brosrv(void);
void    broclean(void);
void    l3rtt_service(void);
BOOLEAN chgnod(int, UWORD, UWORD, int, char *, char *,
               char *, char *, int);
void    newnod(UWORD, UWORD, int, char *, char *, int);
void    addweg(char mode, UWORD, UWORD, WORD);
void    delrou(WORD);
void    todest(NODE *, MBHEAD *);
void    toneig(PEER *, MBHEAD *);
void    makrou(void);
void    destot(int);
UWORD   isgood(void);
int     iscall(char *, NODE **, PEER **, int);
int     find_alias(char *);
PEER   *updnbr(char *, char *, int, int);
PEER   *getnei(char *, char *, int);
BOOLEAN connbr(PEER *);
int     nbrprt(char *);
WORD    istweg(char *, char *, int);
BOOLEAN isneig(char *, char *, int, PEER *);
BOOLEAN ge6chr(char *, MBHEAD *);
void    pu6chr(char *, MBHEAD *);
void    rx_broadcast(PEER *,MBHEAD *);
void    send_bro_i (MBHEAD  *, PEER *);
void    send_bro_ui(MBHEAD  *, PEER *);
void    send_frame_to_level2(void);
void    cpyidl2(char *,char *);
BOOLEAN cmpidl2(char *,char *);
BOOLEAN tol3sw(MBHEAD *);
BOOLEAN check_destot(int);
PEER   *is_neigb_call(char *);
void    l3find(char *);
void    l3_status_rx(MBHEAD *);
#define find_best_qual(index, pp, opt) do_find_best_qual(index, NULL, pp, opt)
#define find_best_notvia(index, notthis, pp, opt) do_find_best_qual(index, notthis, pp, opt)
unsigned do_find_best_qual(int, PEER *, PEER **, int);
void    unregister_neigb(char *, char *, int);
PEER   *register_neigb(char *, char *, char *, int, int);
BOOLEAN l3startup(void);
void    i3tolnk(UBYTE, LNKBLK *, MBHEAD *);
void    update_primary_peer(char *);

/*-------------------------------------------------- Funktionen in L4.C */

void    initl4(void);
void    l4serv(void);
void    l4tx(void);
void    l4rx(NODE *, NODE *, MBHEAD *);
BOOLEAN l4istome(char *, char *);
void    l4rest(void);
void    trasrv(void);
void    newcir(void);
void    discir(void);
BOOLEAN itocir(BOOLEAN, MBHEAD *);
void    clr4rx(BOOLEAN);
void    chksts(void);
void    takfrm(MBHEAD *);
void    sndfrm(int, MBHEAD *);
void    l4nsta(WORD);
void    endcir(void);
void    clrcir(void);
void    sconrq(void);
void    sdisrq(void);
void    sndack(void);
void    ackhdr(void);
void    itol3(WORD,MBHEAD *);
MBHEAD  *gennhd(void);
void    kilfra(void);
void    l3tol4(NODE *);
void    gensta(UWORD,UWORD);
void    sndsta(void);

/*-------------------------------------------------- Funktionen in L7.C */

void    initl7(void);
void    l7rx(void);
void    l7tx(void);
void    inivar(void);
void    timsrv(void);
void    inv_cmd(void);
void    program_load(MBHEAD *);
void    start_autobin(void);
void    load_text(void);
void    get_password(void);
void    l2tol7(WORD, void *, WORD);
void    disusr(UID);
BOOLEAN fmlink(BOOLEAN, MBHEAD *);
void    seteom(MBHEAD *);
BOOLEAN send_msg(BOOLEAN, MBHEAD *);
void    beacsv(void);
void    tlmsrv(void);
BOOLEAN new_user(BOOLEAN check, UID);
BOOLEAN read_txt(void);
BOOLEAN do_file(char *directory);
BOOLEAN extern_command(void);
BOOLEAN intern_command(COMAND *tabelle);
BOOLEAN is_down_suspended(char *user_call, int user_port);
BOOLEAN is_suspended(USRBLK *);

UID     g_uid(void *, UBYTE);
UBYTE   g_utyp(UID);
void   *g_ulink(UID);
void    resptc(UID);
void    clrptc(UID);

/*----------------------------------------------- Funktionen in L7CCP.C */

void    ccpalias(void);
void    ccpbox(void);
void    ccppacsat(void);
void    ccpecho(void);
void    ccpcon(char *);
void    ccpcq(void);
void    ccpbea(void);
void    ccpdcd(void);
void    ccpread(char *);
void    ccpreadb(void);
void    ccpedi(void);
void    ccpload(void);
void    ccpnod(void);
void    ccpdest(void);
void    ccplocal(void);
void    ccprou(void);
void    ccpsys(void);
void    ccpuse(void);
void    viaput(WORD, UID, MBHEAD *);
void    ccpbcn(void);
void    ccptim(void);
void    ccpclr(void);
void    ccpsta(void);
void    ccpmh(void);
BOOLEAN mhprm(char *, WORD, UBYTE *);
BOOLEAN c6mtch( UBYTE *, UBYTE *);
BOOLEAN pnmtch( UBYTE *, UBYTE *);
void    ccptst(void);
void    ccpver(void);
void    ccplnk(void);
void    ccpquit(void);
void    ccptalk(void);
BOOLEAN talk_to(char *call, WORD test);
void    ccpmail(void);
void    ccpdxc(void);
#ifdef PADDLE
void    ccppaddle(void);
#endif
#define NOPORT     (-1)
#define MHEARD_UNKNOWN   1
#define MHEARD_AVAILABLE 0
BOOLEAN isheard(char *id, DEST *dest);

/*---------------------------------------------- Funktionen in L7CMDS.C */
void    ccpstart(void);
void    ccppar(void);
void    ccpres(void);
void    ccpprompt(void);
#ifdef MC68302
void    ccpcopy(void);
void    ccpdir(void);
void    ccpdelete(void);
#endif
void    ccpsyspro(void);
void    ccpshell(void);
void    ccpport(void);
void    ccphelp(void);
void    ccpsusp(void);
void    ccpesc(void);
void    ccprun(void);

char   *get_vialist(char *);
void    ccppath(void);
void    ccpsave(void);
void    save_parms(void);
void    ccpkill(void);
void    ccpfind(void);
void    ccptrace(void);
void    ccpgraph(void);

/*---------------------------------------------- Funktionen in L7HOST.C */

void    init_host(void);
void    exit_host(void);

void    hosini(void);
void    hostsv(void);
void    hostim(void);
BOOLEAN hstreq(void);
void    hstout(void);
BOOLEAN itohst(BOOLEAN, MBHEAD *);
void    blieco(int);
void    bliloe(void);
void    bputbs(void);
void    hstcmd(MBHEAD *);
void    hstcon(void);
void    hstdis(void);
void    hstsen(BOOLEAN);
void    invcmd(void);
void    invpar(void);
void    hputv(WORD, char *);
void    hputvl(WORD, char *);
void    hputid(char *);
void    hputc(char);
void    hputcc(char);
void    hputby(UBYTE);
void    hputbt(time_t *);
void    hprintf(const char *, ...);
void    hputs(const char *);
void    hputmb(MBHEAD *);
void    xprintf(const char *, ...);
void    rspic(unsigned);
void    rspsuc(void);
void    rspini(unsigned);
void    rspex(void);
void    rsperr(int);
void    rspcs(void);
void    hmputr(unsigned);

BOOLEAN runbatch(char *);

/*--------------------------------------------------------CVS_CVSD.C*/

void    send_proto    __ARGS((char *modul, const char *format __DOTS));
void    send_proto_to __ARGS((int channel,char *modul, const char *format __DOTS));

char    *personalmanager __ARGS((WORD, CONNECTION *, char *));

/*--------------------------------------------------------CVS_SERV.C*/

void    convers_init __ARGS((void));
void    conversd __ARGS((void));
BOOLEAN convers_input __ARGS((MBHEAD *));
void    convers_output __ARGS((void));
void    ccpcvs __ARGS((void));

/*---------------------------------------------------------- CVS_CMDS.C */

void    bye_command2 __ARGS((CONNECTION *cp, char *reason));

/*-------------------------------------------- Funktionen in L7HSTCMD.C */

void    Bcmd(void);             /* Anzahl der Runden / Sekunde          */
void    Ccmd(void);             /* An Console connecten                 */
void    Dcmd(void);             /* Von Console disconnecten             */
void    Ecmd(void);             /* Ausgabe auf File umleiten            */
void    Gcmd(void);             /* Hostmode-Poll                        */
void    xGcmd(void);            /* erweiterter Hostmode-Poll            */
void    Icmd(void);             /* Rufzeichen, Alias, Login-Passwort    */
void    Kcmd(void);             /* Datum + Uhrzeit anzeigen             */
void    Lcmd(void);             /* Status der Hostkanaele abfragen      */
void    Pcmd(void);             /* SYSOP-Passwort                       */
void    Rcmd(void);             /* Token-Recoveries anzeigen j/n        */
void    Ycmd(void);             /* Connect zum Host erlaubt j/n         */
void    Jcmd(void);             /* JHOST ein/aus                        */
void    Mcmd(void);             /* Monitor einstellen                   */
void    Qcmd(void);             /* Programm verlassen: QUIT             */
void    Scmd(void);             /* Hostkanal waehlen                    */
void    Tcmd(void);             /* Token-Ring-Baudrate einstellen       */
void    Vcmd(void);             /* Version abfragen                     */
void    extcmd(void);           /* erweiterte Befehle                   */

/*---------------------------------------------- Funktionen in L7MONI.C */

void    monitor(MBHEAD *);
void    statsv(int, int, BOOLEAN);
void    frhmon(MBHEAD *, MBHEAD *);
void    frimon(MBHEAD *, MBHEAD *);
BOOLEAN ismonf(MBHEAD *, MONBUF *);
BOOLEAN invial(char *, char *);
void    moncmd(MBHEAD *, MONBUF *, char *, WORD);

/*--------------------------------------------- Funktionen in L7UTILS.C */
void    kilusr(void);
void    invcal(void);
void    msgfrm(WORD,UID,char *);
void    puttfu(char *);
void    putmsg(char *);
MBHEAD  *putals(char *);
MBHEAD  *getmbp(void);
void    putnbr(PEER *,MBHEAD *);
void    putuse(WORD, UID, MBHEAD *);
void    putdil(char *,MBHEAD *);
void    putid(char *,MBHEAD *);
void    putalt(char *,MBHEAD *);
void    putcal(char *,MBHEAD *);
void    puttim(time_t *, MBHEAD *);
void    putnum(int,MBHEAD *);
void    putlong(ULONG, BOOLEAN, MBHEAD *);
void    putstr(char *,MBHEAD *);
void    putspa(WORD, MBHEAD *);
void    putcvsu(USRBLK *, MBHEAD *);
void    vputstr(char *string, MBHEAD *mbp, ...);
void    putprintf(MBHEAD *mbp, const char *format, ...);
BOOLEAN getqua(void);
BOOLEAN getpar(void);
WORD    getdig(WORD *, char **, BOOLEAN, char *);
WORD    getcal(WORD *, char **, BOOLEAN ,char *);
BOOLEAN getport(WORD *, char **, WORD *);
WORD    getide(WORD *, char **, char *);
UWORD   nxtnum(WORD *, char **);
LONG    nxtlong(WORD *, char **);
WORD    fvalca(WORD, char *);
WORD    valcal(char *);
BOOLEAN ismemr(void);
void    setl2b(void);
char    *calofs(WORD, UID);
BOOLEAN getlin(MBHEAD *);
void    invsid(void);
BOOLEAN issyso(void);
BOOLEAN skipsp(WORD *,char **);
BOOLEAN nextspace(WORD *, char **);
WORD    getparam(WORD *, char **, WORD, WORD, WORD);
void    prompt(MBHEAD *);
void    prompt2str(MBHEAD *, char *);
void    putide(char *, MBHEAD *);
void    putkbytes(ULONG, MBHEAD *);
void    call2str(char *, char *);
void    callss2str(char *, char *);
void    str2call(char *, char *);
int     userport(USRBLK *);
void    send_ctext(void);
void    init_crctab(void);
void    invmsg(void);
void    dump_beacn(MBHEAD *mbp);
void    dump_convc(MBHEAD *mbp);
void    dump_links(MBHEAD *mbp);
void    dump_local(MBHEAD *mbp);
void    dump_parms(MBHEAD *mbp);
void    dump_paths(MBHEAD *mbp);
void    dump_ports(MBHEAD *mbp);
void    dump_stats(MBHEAD *mbp);
void    dump_suspd(MBHEAD *mbp);
void    dump_ipr(MBHEAD *mbp);
void    dump_divrs(MBHEAD *mbp);
void    send_async_response(USRBLK *, char *, char *);
void    ccp_par(char *name, PARAM *partab, int len);
void    ccp_call(char *id);
void    notify(int level, const char *format __DOTS);
int     ptc_p_max(void *link, UBYTE typ);

/*------------------------------------------------ Funktionen in FILE.C */

BOOLEAN save_configuration(void);
BOOLEAN save_stat(void);
BOOLEAN load_configuration(void);
BOOLEAN load_stat(void);
void    addslash(char *);

/*-------------------------------------------------- Funktionen in MH.C */

void    init_mh(void);
void    exit_mh(void);
void    save_mh(void);
BOOLEAN heard_user(char *, char *);
void    ccpl2mh(void);
void    ccpl3mh(void);
BOOLEAN mhprm(char *, WORD, UBYTE *);

MHEARD *mh_lookup(MHTAB *mh, char *id);
void mh_update(MHTAB *mh, MHEARD *mhp, char *id, UWORD port);
void mh_clear(MHEARD *mhp);
MHEARD *mh_add(MHTAB *mh);

/*----------------------------------------------- Funktionen in 16550.C */

void clear_rs232(int);
void close_rs232(int);
void rts_off(int);
void rts_on(int);
int setbaud (int, int);
void setstopbits(int, int);
int rs232_in(int dev);
void rs232_out(int dev, int c);
int rs232_read(int, UBYTE *, int);
void rs232_write(int, UBYTE *, UBYTE *);
int rs232_in_status(int dev);
int rs232_out_status(int dev);
void init_rs232(void);
#if defined (__DOS16__) || defined (__GNU32__)
void read_envcom(char *what, int *dev, int *adr, int *irq);
int  open_rs232(int, int, int, int, int);
#endif
#ifdef ST
void read_envdev(char *, char *,char *);
int  open_rs232(char *);
#endif
#ifdef MC68302
int  open_rs232(int);
#endif

/*----------------------------------------------- Funktionen in TIMER.C */

void    init_timer(void);
void    exit_timer(void);

/*---------------------------------------------- Funktionen in Buffer.C */

void    rwndmb(MBHEAD *);
LEHEAD  *allocb(void);
LEHEAD  *ulink(LEHEAD *);
LEHEAD  *relink(LEHEAD *, LEHEAD *);
void    dealml(LEHEAD *);
void    dealmb(MBHEAD *);
void    dealoc(MBHEAD *);
void    inithd(LHEAD *);
void    init_buffers(void);

/*--------------------------------------------- Funktionen von MEM386.C */

#if defined (__DOS16__)
void    done_umb(void);
void    alloc_umb(void);
#endif

/*---------------------------------------------- Funktionen L3C.C */

void flex_srv(void);
void flex_rx(PEER *, MBHEAD *);
int  l3_find_route(char *, DEST *);
#define NODE_UNKNOWN   1
#define NODE_DOWN      2
#define NODE_AVAILABLE 0
void gateway_ui(char *, char *, char *, MBHEAD *);
void flex_route_query(char *);


/*---------------------------------------------- Funktionen PACSERV.C */

void pacsat_init(void);
void pacsrv(void);
void l7_to_pacsat(void);

UWORD get16( MBHEAD * );
void  put16( UWORD , MBHEAD * );
ULONG get32( MBHEAD * );
void  put32( ULONG , MBHEAD * );

/* End of FUNCTiON.H */

